(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('react-bootstrap')) :
	typeof define === 'function' && define.amd ? define('@auth0/styleguide-react-components', ['exports', 'react', 'react-bootstrap'], factory) :
	(factory((global.auth0StyleguideReactComponents = global.auth0StyleguideReactComponents || {}),global.React,global.ReactBootstrap));
}(this, (function (exports,React,reactBootstrap) { 'use strict';

var React__default = 'default' in React ? React['default'] : React;

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

/*
object-assign
(c) Sindre Sorhus
@license MIT
*/

/* eslint-disable no-unused-vars */

var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}

	return Object(val);
}

function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}

		// Detect buggy property enumeration order in older V8 versions.

		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
		var test1 = new String('abc'); // eslint-disable-line no-new-wrappers
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !== 'abcdefghijklmnopqrst') {
			return false;
		}

		return true;
	} catch (err) {
		// We don't expect any of the above to throw, but better to be safe.
		return false;
	}
}

var index$1 = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;

	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);

		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}

		if (getOwnPropertySymbols) {
			symbols = getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}

	return to;
};

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var ReactPropTypesSecret$1 = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

var ReactPropTypesSecret_1 = ReactPropTypesSecret$1;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};





















var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var get = function get(object, property, receiver) {
  if (object === null) object = Function.prototype;
  var desc = Object.getOwnPropertyDescriptor(object, property);

  if (desc === undefined) {
    var parent = Object.getPrototypeOf(object);

    if (parent === null) {
      return undefined;
    } else {
      return get(parent, property, receiver);
    }
  } else if ("value" in desc) {
    return desc.value;
  } else {
    var getter = desc.get;

    if (getter === undefined) {
      return undefined;
    }

    return getter.call(receiver);
  }
};











var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};





var set = function set(object, property, value, receiver) {
  var desc = Object.getOwnPropertyDescriptor(object, property);

  if (desc === undefined) {
    var parent = Object.getPrototypeOf(object);

    if (parent !== null) {
      set(parent, property, value, receiver);
    }
  } else if ("value" in desc && desc.writable) {
    desc.value = value;
  } else {
    var setter = desc.set;

    if (setter !== undefined) {
      setter.call(receiver, value);
    }
  }

  return value;
};

var printWarning$1 = function printWarning$1() {};

{
  var ReactPropTypesSecret$2 = ReactPropTypesSecret_1;
  var loggedTypeFailures = {};

  printWarning$1 = function printWarning$1(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

/**
 * Assert that the values match with the type specs.
 * Error messages are memorized and will only be shown once.
 *
 * @param {object} typeSpecs Map of name to a ReactPropType
 * @param {object} values Runtime values that need to be type-checked
 * @param {string} location e.g. "prop", "context", "child context"
 * @param {string} componentName Name of the component for error messages.
 * @param {?Function} getStack Returns the component stack.
 * @private
 */
function checkPropTypes$1(typeSpecs, values, location, componentName, getStack) {
  {
    for (var typeSpecName in typeSpecs) {
      if (typeSpecs.hasOwnProperty(typeSpecName)) {
        var error;
        // Prop type validation may throw. In case they do, we don't want to
        // fail the render phase where it didn't fail before. So we log it.
        // After these have been cleaned up, we'll let them throw.
        try {
          // This is intentionally an invariant that gets caught. It's the same
          // behavior as without this statement except with a better message.
          if (typeof typeSpecs[typeSpecName] !== 'function') {
            var err = Error((componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' + 'it must be a function, usually from the `prop-types` package, but received `' + _typeof(typeSpecs[typeSpecName]) + '`.');
            err.name = 'Invariant Violation';
            throw err;
          }
          error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret$2);
        } catch (ex) {
          error = ex;
        }
        if (error && !(error instanceof Error)) {
          printWarning$1((componentName || 'React class') + ': type specification of ' + location + ' `' + typeSpecName + '` is invalid; the type checker ' + 'function must return `null` or an `Error` but returned a ' + (typeof error === 'undefined' ? 'undefined' : _typeof(error)) + '. ' + 'You may have forgotten to pass an argument to the type checker ' + 'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' + 'shape all require an argument).');
        }
        if (error instanceof Error && !(error.message in loggedTypeFailures)) {
          // Only monitor this failure once because there tends to be a lot of the
          // same error.
          loggedTypeFailures[error.message] = true;

          var stack = getStack ? getStack() : '';

          printWarning$1('Failed ' + location + ' type: ' + error.message + (stack != null ? stack : ''));
        }
      }
    }
  }
}

var checkPropTypes_1 = checkPropTypes$1;

var assign = index$1;

var ReactPropTypesSecret = ReactPropTypesSecret_1;
var checkPropTypes = checkPropTypes_1;

var printWarning = function printWarning() {};

{
  printWarning = function printWarning(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

function emptyFunctionThatReturnsNull() {
  return null;
}

var factoryWithTypeCheckers = function factoryWithTypeCheckers(isValidElement, throwOnDirectAccess) {
  /* global Symbol */
  var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
  var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

  /**
   * Returns the iterator method function contained on the iterable object.
   *
   * Be sure to invoke the function with the iterable as context:
   *
   *     var iteratorFn = getIteratorFn(myIterable);
   *     if (iteratorFn) {
   *       var iterator = iteratorFn.call(myIterable);
   *       ...
   *     }
   *
   * @param {?object} maybeIterable
   * @return {?function}
   */
  function getIteratorFn(maybeIterable) {
    var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
    if (typeof iteratorFn === 'function') {
      return iteratorFn;
    }
  }

  /**
   * Collection of methods that allow declaration and validation of props that are
   * supplied to React components. Example usage:
   *
   *   var Props = require('ReactPropTypes');
   *   var MyArticle = React.createClass({
   *     propTypes: {
   *       // An optional string prop named "description".
   *       description: Props.string,
   *
   *       // A required enum prop named "category".
   *       category: Props.oneOf(['News','Photos']).isRequired,
   *
   *       // A prop named "dialog" that requires an instance of Dialog.
   *       dialog: Props.instanceOf(Dialog).isRequired
   *     },
   *     render: function() { ... }
   *   });
   *
   * A more formal specification of how these methods are used:
   *
   *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
   *   decl := ReactPropTypes.{type}(.isRequired)?
   *
   * Each and every declaration produces a function with the same signature. This
   * allows the creation of custom validation functions. For example:
   *
   *  var MyLink = React.createClass({
   *    propTypes: {
   *      // An optional string or URI prop named "href".
   *      href: function(props, propName, componentName) {
   *        var propValue = props[propName];
   *        if (propValue != null && typeof propValue !== 'string' &&
   *            !(propValue instanceof URI)) {
   *          return new Error(
   *            'Expected a string or an URI for ' + propName + ' in ' +
   *            componentName
   *          );
   *        }
   *      }
   *    },
   *    render: function() {...}
   *  });
   *
   * @internal
   */

  var ANONYMOUS = '<<anonymous>>';

  // Important!
  // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
  var ReactPropTypes = {
    array: createPrimitiveTypeChecker('array'),
    bool: createPrimitiveTypeChecker('boolean'),
    func: createPrimitiveTypeChecker('function'),
    number: createPrimitiveTypeChecker('number'),
    object: createPrimitiveTypeChecker('object'),
    string: createPrimitiveTypeChecker('string'),
    symbol: createPrimitiveTypeChecker('symbol'),

    any: createAnyTypeChecker(),
    arrayOf: createArrayOfTypeChecker,
    element: createElementTypeChecker(),
    instanceOf: createInstanceTypeChecker,
    node: createNodeChecker(),
    objectOf: createObjectOfTypeChecker,
    oneOf: createEnumTypeChecker,
    oneOfType: createUnionTypeChecker,
    shape: createShapeTypeChecker,
    exact: createStrictShapeTypeChecker
  };

  /**
   * inlined Object.is polyfill to avoid requiring consumers ship their own
   * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
   */
  /*eslint-disable no-self-compare*/
  function is(x, y) {
    // SameValue algorithm
    if (x === y) {
      // Steps 1-5, 7-10
      // Steps 6.b-6.e: +0 != -0
      return x !== 0 || 1 / x === 1 / y;
    } else {
      // Step 6.a: NaN == NaN
      return x !== x && y !== y;
    }
  }
  /*eslint-enable no-self-compare*/

  /**
   * We use an Error-like object for backward compatibility as people may call
   * PropTypes directly and inspect their output. However, we don't use real
   * Errors anymore. We don't inspect their stack anyway, and creating them
   * is prohibitively expensive if they are created too often, such as what
   * happens in oneOfType() for any type before the one that matched.
   */
  function PropTypeError(message) {
    this.message = message;
    this.stack = '';
  }
  // Make `instanceof Error` still work for returned errors.
  PropTypeError.prototype = Error.prototype;

  function createChainableTypeChecker(validate) {
    {
      var manualPropTypeCallCache = {};
      var manualPropTypeWarningCount = 0;
    }
    function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
      componentName = componentName || ANONYMOUS;
      propFullName = propFullName || propName;

      if (secret !== ReactPropTypesSecret) {
        if (throwOnDirectAccess) {
          // New behavior only for users of `prop-types` package
          var err = new Error('Calling PropTypes validators directly is not supported by the `prop-types` package. ' + 'Use `PropTypes.checkPropTypes()` to call them. ' + 'Read more at http://fb.me/use-check-prop-types');
          err.name = 'Invariant Violation';
          throw err;
        } else if ("development" !== 'production' && typeof console !== 'undefined') {
          // Old behavior for people using React.PropTypes
          var cacheKey = componentName + ':' + propName;
          if (!manualPropTypeCallCache[cacheKey] &&
          // Avoid spamming the console because they are often not actionable except for lib authors
          manualPropTypeWarningCount < 3) {
            printWarning('You are manually calling a React.PropTypes validation ' + 'function for the `' + propFullName + '` prop on `' + componentName + '`. This is deprecated ' + 'and will throw in the standalone `prop-types` package. ' + 'You may be seeing this warning due to a third-party PropTypes ' + 'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.');
            manualPropTypeCallCache[cacheKey] = true;
            manualPropTypeWarningCount++;
          }
        }
      }
      if (props[propName] == null) {
        if (isRequired) {
          if (props[propName] === null) {
            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
          }
          return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
        }
        return null;
      } else {
        return validate(props, propName, componentName, location, propFullName);
      }
    }

    var chainedCheckType = checkType.bind(null, false);
    chainedCheckType.isRequired = checkType.bind(null, true);

    return chainedCheckType;
  }

  function createPrimitiveTypeChecker(expectedType) {
    function validate(props, propName, componentName, location, propFullName, secret) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== expectedType) {
        // `propValue` being instance of, say, date/regexp, pass the 'object'
        // check, but we can offer a more precise error message here rather than
        // 'of type `object`'.
        var preciseType = getPreciseType(propValue);

        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createAnyTypeChecker() {
    return createChainableTypeChecker(emptyFunctionThatReturnsNull);
  }

  function createArrayOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
      }
      var propValue = props[propName];
      if (!Array.isArray(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
      }
      for (var i = 0; i < propValue.length; i++) {
        var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret);
        if (error instanceof Error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!isValidElement(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createInstanceTypeChecker(expectedClass) {
    function validate(props, propName, componentName, location, propFullName) {
      if (!(props[propName] instanceof expectedClass)) {
        var expectedClassName = expectedClass.name || ANONYMOUS;
        var actualClassName = getClassName(props[propName]);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createEnumTypeChecker(expectedValues) {
    if (!Array.isArray(expectedValues)) {
      printWarning('Invalid argument supplied to oneOf, expected an instance of array.');
      return emptyFunctionThatReturnsNull;
    }

    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      for (var i = 0; i < expectedValues.length; i++) {
        if (is(propValue, expectedValues[i])) {
          return null;
        }
      }

      var valuesString = JSON.stringify(expectedValues);
      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + propValue + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createObjectOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
      }
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
      }
      for (var key in propValue) {
        if (propValue.hasOwnProperty(key)) {
          var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret);
          if (error instanceof Error) {
            return error;
          }
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createUnionTypeChecker(arrayOfTypeCheckers) {
    if (!Array.isArray(arrayOfTypeCheckers)) {
      printWarning('Invalid argument supplied to oneOfType, expected an instance of array.');
      return emptyFunctionThatReturnsNull;
    }

    for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
      var checker = arrayOfTypeCheckers[i];
      if (typeof checker !== 'function') {
        printWarning('Invalid argument supplied to oneOfType. Expected an array of check functions, but ' + 'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.');
        return emptyFunctionThatReturnsNull;
      }
    }

    function validate(props, propName, componentName, location, propFullName) {
      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
        var checker = arrayOfTypeCheckers[i];
        if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret) == null) {
          return null;
        }
      }

      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createNodeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      if (!isNode(props[propName])) {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      for (var key in shapeTypes) {
        var checker = shapeTypes[key];
        if (!checker) {
          continue;
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret);
        if (error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createStrictShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      // We need to check all keys in case some are required but missing from
      // props.
      var allKeys = assign({}, props[propName], shapeTypes);
      for (var key in allKeys) {
        var checker = shapeTypes[key];
        if (!checker) {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' + '\nBad object: ' + JSON.stringify(props[propName], null, '  ') + '\nValid keys: ' + JSON.stringify(Object.keys(shapeTypes), null, '  '));
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret);
        if (error) {
          return error;
        }
      }
      return null;
    }

    return createChainableTypeChecker(validate);
  }

  function isNode(propValue) {
    switch (typeof propValue === 'undefined' ? 'undefined' : _typeof(propValue)) {
      case 'number':
      case 'string':
      case 'undefined':
        return true;
      case 'boolean':
        return !propValue;
      case 'object':
        if (Array.isArray(propValue)) {
          return propValue.every(isNode);
        }
        if (propValue === null || isValidElement(propValue)) {
          return true;
        }

        var iteratorFn = getIteratorFn(propValue);
        if (iteratorFn) {
          var iterator = iteratorFn.call(propValue);
          var step;
          if (iteratorFn !== propValue.entries) {
            while (!(step = iterator.next()).done) {
              if (!isNode(step.value)) {
                return false;
              }
            }
          } else {
            // Iterator will provide entry [k,v] tuples rather than values.
            while (!(step = iterator.next()).done) {
              var entry = step.value;
              if (entry) {
                if (!isNode(entry[1])) {
                  return false;
                }
              }
            }
          }
        } else {
          return false;
        }

        return true;
      default:
        return false;
    }
  }

  function isSymbol(propType, propValue) {
    // Native Symbol.
    if (propType === 'symbol') {
      return true;
    }

    // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
    if (propValue['@@toStringTag'] === 'Symbol') {
      return true;
    }

    // Fallback for non-spec compliant Symbols which are polyfilled.
    if (typeof Symbol === 'function' && propValue instanceof Symbol) {
      return true;
    }

    return false;
  }

  // Equivalent of `typeof` but with special handling for array and regexp.
  function getPropType(propValue) {
    var propType = typeof propValue === 'undefined' ? 'undefined' : _typeof(propValue);
    if (Array.isArray(propValue)) {
      return 'array';
    }
    if (propValue instanceof RegExp) {
      // Old webkits (at least until Android 4.0) return 'function' rather than
      // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
      // passes PropTypes.object.
      return 'object';
    }
    if (isSymbol(propType, propValue)) {
      return 'symbol';
    }
    return propType;
  }

  // This handles more types than `getPropType`. Only used for error messages.
  // See `createPrimitiveTypeChecker`.
  function getPreciseType(propValue) {
    if (typeof propValue === 'undefined' || propValue === null) {
      return '' + propValue;
    }
    var propType = getPropType(propValue);
    if (propType === 'object') {
      if (propValue instanceof Date) {
        return 'date';
      } else if (propValue instanceof RegExp) {
        return 'regexp';
      }
    }
    return propType;
  }

  // Returns a string that is postfixed to a warning about an invalid type.
  // For example, "undefined" or "of type array"
  function getPostfixForTypeWarning(value) {
    var type = getPreciseType(value);
    switch (type) {
      case 'array':
      case 'object':
        return 'an ' + type;
      case 'boolean':
      case 'date':
      case 'regexp':
        return 'a ' + type;
      default:
        return type;
    }
  }

  // Returns class name of the object, if any.
  function getClassName(propValue) {
    if (!propValue.constructor || !propValue.constructor.name) {
      return ANONYMOUS;
    }
    return propValue.constructor.name;
  }

  ReactPropTypes.checkPropTypes = checkPropTypes;
  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

var ReactPropTypesSecret$3 = ReactPropTypesSecret_1;

var index = createCommonjsModule(function (module) {
  /**
   * Copyright (c) 2013-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  {
    var REACT_ELEMENT_TYPE = typeof Symbol === 'function' && Symbol.for && Symbol.for('react.element') || 0xeac7;

    var isValidElement = function isValidElement(object) {
      return (typeof object === 'undefined' ? 'undefined' : _typeof(object)) === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
    };

    // By explicitly using `prop-types` you are opting into new development behavior.
    // http://fb.me/prop-types-in-prod
    var throwOnDirectAccess = true;
    module.exports = factoryWithTypeCheckers(isValidElement, throwOnDirectAccess);
  }
});

/**
 * Empty state: Simple component for onboarding users to sections with no data.
 */
var EmptyState = function EmptyState(_ref) {
  var title = _ref.title,
      description = _ref.description,
      iconCode = _ref.iconCode,
      image = _ref.image,
      children = _ref.children;
  return React__default.createElement(
    'div',
    { className: 'a0r-empty-state' },
    React__default.createElement(
      'h2',
      { className: 'a0r-empty-state-title' },
      title
    ),
    image || React__default.createElement(
      'div',
      { className: 'a0r-empty-state-icon' },
      React__default.createElement('i', { className: 'icon-budicon-' + iconCode })
    ),
    description && React__default.createElement(
      'p',
      { className: 'a0r-empty-state-description' },
      description
    ),
    React__default.createElement(
      'div',
      { className: 'a0r-empty-state-children' },
      ' ',
      children,
      ' '
    )
  );
};

EmptyState.defaultProps = {
  iconCode: '750',
  image: false,
  children: undefined
};

EmptyState.propTypes = {
  title: index.string.isRequired,
  description: index.string.isRequired,
  iconCode: index.string,
  image: index.node,
  children: index.node
};

/**
 * Footer: Auth0's footer component. Styles are inherited from components CSS bundle.
 */
var Footer = function Footer() {
  return React__default.createElement(
    "footer",
    { role: "contentinfo", className: "sc-footer" },
    React__default.createElement(
      "div",
      { className: "container" },
      React__default.createElement(
        "div",
        { className: "sc-footer__logo" },
        React__default.createElement("img", {
          src: "https://cdn.auth0.com/styleguide/components/1.0.8/media/logos/img/badge.png",
          width: 30,
          className: "sc-footer__logo-image",
          alt: ""
        })
      ),
      React__default.createElement(
        "div",
        { className: "sc-footer__grid" },
        React__default.createElement(
          "div",
          { className: "sc-footer__column sc-footer__column--grid" },
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "h6",
              { className: "sc-footer__title" },
              "Product"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              {
                href: "https://auth0.com/pricing",
                className: "sc-footer__link sc-footer__link--featured"
              },
              "Pricing"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              {
                href: "https://auth0.com/why-auth0",
                className: "sc-footer__link sc-footer__link--featured"
              },
              "Why Auth0"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              {
                href: "https://auth0.com/how-it-works",
                className: "sc-footer__link sc-footer__link--featured"
              },
              "How It Works"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              { href: "https://auth0.com/lock", className: "sc-footer__link sc-footer__link--featured" },
              "Lock"
            )
          )
        ),
        React__default.createElement(
          "div",
          { className: "sc-footer__column sc-footer__column--grid" },
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "h6",
              { className: "sc-footer__title" },
              "Company"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              { href: "https://auth0.com/about", className: "sc-footer__link sc-footer__link--featured" },
              "About Us"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              { href: "https://auth0.com/blog", className: "sc-footer__link sc-footer__link--featured" },
              "Blog"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              { href: "https://auth0.com/jobs", className: "sc-footer__link sc-footer__link--featured" },
              "Jobs"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              { href: "https://auth0.com/press", className: "sc-footer__link sc-footer__link--featured" },
              "Press"
            )
          )
        ),
        React__default.createElement(
          "div",
          { className: "sc-footer__column sc-footer__column--grid" },
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "h6",
              { className: "sc-footer__title" },
              "Learn"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              {
                href: "https://auth0.com/availability-trust",
                className: "sc-footer__link sc-footer__link--featured"
              },
              "Availability & Trust"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              {
                href: "https://auth0.com/security",
                className: "sc-footer__link sc-footer__link--featured"
              },
              "Security"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              {
                href: "https://auth0.com/whitehat",
                className: "sc-footer__link sc-footer__link--featured"
              },
              "White Hat"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              {
                href: "https://auth0.com/docs/apiv2",
                className: "sc-footer__link sc-footer__link--featured"
              },
              "API Explorer"
            )
          )
        ),
        React__default.createElement(
          "div",
          { className: "sc-footer__column sc-footer__column--grid" },
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "h6",
              { className: "sc-footer__title" },
              "More"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              {
                href: "https://support.auth0.com",
                className: "sc-footer__link sc-footer__link--featured"
              },
              "Help & Support"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              { href: "https://auth0.com/docs", className: "sc-footer__link sc-footer__link--featured" },
              "Documentation"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              {
                href: "https://auth0.com/opensource",
                className: "sc-footer__link sc-footer__link--featured"
              },
              "Open Source"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__item" },
            React__default.createElement(
              "a",
              {
                href: "https://auth0.com/wordpress",
                className: "sc-footer__link sc-footer__link--featured"
              },
              "WordPress"
            )
          )
        ),
        React__default.createElement(
          "div",
          { className: "sc-footer__column sc-footer__column--contact" },
          React__default.createElement(
            "div",
            { className: "sc-footer__contact-column sc-footer__contact-column--address" },
            React__default.createElement(
              "div",
              { className: "sc-footer__item" },
              React__default.createElement(
                "h6",
                { className: "sc-footer__title" },
                "Contact"
              )
            ),
            React__default.createElement(
              "div",
              { className: "sc-footer__item sc-footer__item--text" },
              "10800 NE 8th Street",
              React__default.createElement("br", null),
              "Suite 600",
              React__default.createElement("br", null),
              "Bellevue, WA 98004"
            )
          ),
          React__default.createElement(
            "div",
            { className: "sc-footer__contact-column sc-footer__contact-column--phone" },
            React__default.createElement(
              "div",
              { className: "sc-footer__item sc-footer__item--small" },
              React__default.createElement(
                "a",
                { href: "tel:+18882352699", className: "sc-footer__link sc-footer__phone" },
                "+1 (888) 235-2699"
              )
            ),
            React__default.createElement(
              "div",
              { className: "sc-footer__item sc-footer__item--small" },
              React__default.createElement(
                "a",
                { href: "tel:+14253126521", className: "sc-footer__link sc-footer__phone" },
                "+1 (425) 312-6521"
              )
            ),
            React__default.createElement(
              "div",
              { className: "sc-footer__item sc-footer__item--small" },
              React__default.createElement(
                "a",
                { href: "tel:+4403332341966", className: "sc-footer__link sc-footer__phone" },
                "+44 (0) 33-3234-1966"
              )
            )
          )
        )
      ),
      React__default.createElement(
        "div",
        { className: "sc-footer__colophon" },
        React__default.createElement(
          "div",
          { className: "sc-footer__column" },
          React__default.createElement(
            "ul",
            { className: "list-inline sc-footer__list sc-footer__like-buttons-container" },
            React__default.createElement(
              "li",
              { className: "sc-footer__list-item" },
              React__default.createElement(
                "a",
                {
                  href: "https://twitter.com/auth0",
                  target: "_blank",
                  rel: "noopener noreferrer",
                  className: "sc-footer__like-buttons__link sc-footer__like-buttons__link--twitter"
                },
                React__default.createElement(
                  "span",
                  { className: "sc-footer__like-buttons__icon-container" },
                  React__default.createElement(
                    "svg",
                    { viewBox: "0 0 72 72", className: "sc-footer__like-buttons__icon" },
                    React__default.createElement("path", { fill: "none", d: "M0 0h72v72H0z" }),
                    React__default.createElement("path", {
                      fill: "#fff",
                      d: "M68.812 15.14c-2.348 1.04-4.87 1.744-7.52 2.06 2.704-1.62 4.78-4.186 5.757-7.243-2.53 1.5-5.33 2.592-8.314 3.176C56.35 10.59 52.948 9 49.182 9c-7.23 0-13.092 5.86-13.092 13.093 0 1.026.118 2.02.338 2.98C25.543 24.527 15.9 19.318 9.44 11.396c-1.125 1.936-1.77 4.184-1.77 6.58 0 4.543 2.312 8.552 5.824 10.9-2.146-.07-4.165-.658-5.93-1.64-.002.056-.002.11-.002.163 0 6.345 4.513 11.638 10.504 12.84-1.1.298-2.256.457-3.45.457-.845 0-1.666-.078-2.464-.23 1.667 5.2 6.5 8.985 12.23 9.09-4.482 3.51-10.13 5.605-16.26 5.605-1.055 0-2.096-.06-3.122-.184 5.794 3.717 12.676 5.882 20.067 5.882 24.083 0 37.25-19.95 37.25-37.25 0-.565-.013-1.133-.038-1.693 2.558-1.847 4.778-4.15 6.532-6.774z"
                    })
                  )
                ),
                React__default.createElement(
                  "span",
                  { className: "sc-footer__like-buttons__action" },
                  "Follow"
                ),
                React__default.createElement(
                  "span",
                  { className: "sr-only" },
                  " us on Twitter, along with "
                ),
                React__default.createElement(
                  "span",
                  { className: "sc-footer__like-buttons__counter sr-only" },
                  "many"
                ),
                React__default.createElement(
                  "span",
                  { className: "sr-only" },
                  " followers!"
                )
              )
            ),
            React__default.createElement(
              "li",
              { className: "sc-footer__list-item" },
              React__default.createElement(
                "a",
                {
                  href: "https://www.linkedin.com/company/auth0",
                  target: "_blank",
                  rel: "noopener noreferrer",
                  className: "sc-footer__like-buttons__link sc-footer__like-buttons__link--linkedin"
                },
                React__default.createElement(
                  "span",
                  { className: "sc-footer__like-buttons__icon-container" },
                  React__default.createElement(
                    "svg",
                    { viewBox: "0 50 512 512", className: "sc-footer__like-buttons__icon" },
                    React__default.createElement("path", {
                      fill: "#ffffff",
                      d: "M150.65 100.682c0 27.992-22.508 50.683-50.273 50.683-27.765 0-50.273-22.69-50.273-50.683C50.104 72.692 72.612 50 100.377 50c27.766 0 50.273 22.69 50.273 50.682zm-7.356 86.65H58.277V462h85.017V187.333zm135.9 0h-81.54V462h81.54V317.82c0-38.625 17.78-61.616 51.808-61.616 31.268 0 46.29 22.07 46.29 61.615V462h84.604V288.085s-41.69-109.13-99.934-109.13-82.768 45.368-82.768 45.368v-36.99z"
                    })
                  )
                ),
                React__default.createElement(
                  "span",
                  { className: "sc-footer__like-buttons__action" },
                  "Follow"
                ),
                React__default.createElement(
                  "span",
                  { className: "sr-only" },
                  " us on LinkedIn, along with "
                ),
                React__default.createElement(
                  "span",
                  { className: "sc-footer__like-buttons__counter sr-only" },
                  "many"
                ),
                React__default.createElement(
                  "span",
                  { className: "sr-only" },
                  " followers!"
                )
              )
            ),
            React__default.createElement(
              "li",
              { className: "sc-footer__list-item" },
              React__default.createElement(
                "a",
                {
                  href: "https://www.facebook.com/getauth0",
                  target: "_blank",
                  rel: "noopener noreferrer",
                  className: "sc-footer__like-buttons__link sc-footer__like-buttons__link--facebook"
                },
                React__default.createElement(
                  "span",
                  { className: "sc-footer__like-buttons__icon-container" },
                  React__default.createElement(
                    "svg",
                    { viewBox: "0 0 16 16", className: "sc-footer__like-buttons__icon" },
                    React__default.createElement("path", {
                      fill: "#fff",
                      fillRule: "evenodd",
                      d: "M4.55 7c.248 0 .45.234.45.522v5.956c0 .288-.202.522-.45.522h-2.1c-.248 0-.45-.234-.45-.522V7.522C2 7.234 2.202 7 2.45 7h2.1zm1.995 6.2c-.305-.036-.528-.302-.545-.626.017 0 .013-2.906 0-4.43.013-.525.108-1.458.398-1.87.708-1.008 1.205-1.666 1.494-2.048.29-.382.636-.755.646-1.04.013-.384 0-.39 0-.83 0-.44.208-.856.733-.856.257 0 .46.057.65.3.304.356.516.92.516 1.81S9.51 6.173 9.51 6.18h4.037c.618-.004.954.545.954 1.117 0 .536-.364.982-.844 1.057.29.14.5.47.5.852 0 .476-.325.872-.756.94.23.145.375.406.375.702 0 .398-.26.733-.615.813.21.14.346.396.346.685 0 .452-.334.823-.763.857H6.545z"
                    })
                  )
                ),
                React__default.createElement(
                  "span",
                  { className: "sc-footer__like-buttons__action" },
                  "Like"
                ),
                React__default.createElement(
                  "span",
                  { className: "sr-only" },
                  " our Facebook page, along with "
                ),
                React__default.createElement(
                  "span",
                  { className: "sc-footer__like-buttons__counter sr-only" },
                  "many"
                ),
                React__default.createElement(
                  "span",
                  { className: "sr-only" },
                  " people!"
                )
              )
            )
          )
        ),
        React__default.createElement(
          "div",
          { className: "sc-footer__column" },
          React__default.createElement(
            "ul",
            { className: "list-inline text-right sc-footer__list" },
            React__default.createElement(
              "li",
              { className: "sc-footer__list-item" },
              React__default.createElement(
                "a",
                { href: "https://auth0.com/privacy", className: "sc-footer__link" },
                "Privacy Policy"
              )
            ),
            React__default.createElement(
              "li",
              { className: "sc-footer__list-item" },
              React__default.createElement(
                "a",
                { href: "https://auth0.com/terms", className: "sc-footer__link" },
                "Terms of Service"
              )
            ),
            React__default.createElement(
              "li",
              { className: "sc-footer__list-item" },
              React__default.createElement(
                "span",
                null,
                "\xA9 2013-2017 Auth0\xAE Inc. All Rights Reserved."
              )
            )
          )
        )
      )
    )
  );
};

/**
 * Select: Drop-down list.
 */
var Select = function Select(_ref) {
  var options = _ref.options,
      selected = _ref.selected,
      label = _ref.label,
      color = _ref.color,
      handleChange = _ref.handleChange;
  return React__default.createElement(
    'div',
    { className: 'a0r-select' },
    label && React__default.createElement(
      'span',
      null,
      label
    ),
    React__default.createElement(
      'span',
      { className: 'a0r-value text-truncate', style: { color: color } },
      options[selected].label
    ),
    React__default.createElement('i', { className: 'icon-budicon-460' }),
    React__default.createElement(
      'select',
      {
        // Pass event and selected option object to onChange handler
        onChange: function onChange(e) {
          return handleChange(e, options.filter(function (opt) {
            return opt.value === e.target.value;
          })[0]);
        },
        value: options[selected].value
      },
      options.map(function (opt) {
        return React__default.createElement(
          'option',
          { key: opt.value, value: opt.value },
          opt.label
        );
      })
    )
  );
};

Select.defaultProps = {
  selected: 0,
  label: '',
  handleChange: function handleChange() {},
  color: undefined
};

Select.propTypes = {
  /**
   * List of options
   */
  options: index.arrayOf(index.shape({
    label: index.string.isRequired,
    value: index.string.isRequired
  })).isRequired,
  /**
   * Index of default selected value
   */
  selected: index.number,
  /**
   * Handler for option change, it receives two parameters:
   * the event and the selected option object.
   */
  handleChange: index.func.isRequired,
  label: index.string,
  color: index.string
};

/* eslint max-len: ["error", 100, { "ignoreComments": true }] */
/**
 * Try Banner: The main call to action to signup.
 */
function TryBanner(_ref) {
  var title = _ref.title,
      button = _ref.button,
      buttonAction = _ref.buttonAction,
      dark = _ref.dark,
      className = _ref.className,
      rest = objectWithoutProperties(_ref, ['title', 'button', 'buttonAction', 'dark', 'className']);

  return React__default.createElement(
    'div',
    _extends({ className: 'a0r-try-banner ' + className + ' ' + (dark ? 'a0r-try-banner--dark' : '') }, rest),
    React__default.createElement(
      'span',
      { className: 'a0r-try-banner__title' },
      title
    ),
    toString.call(buttonAction) === '[object String]' ? React__default.createElement(
      'a',
      { className: 'a0r-try-banner__button btn btn-success btn-lg', href: buttonAction },
      button
    ) : React__default.createElement(
      'button',
      { className: 'a0r-try-banner__button btn btn-success btn-lg', onClick: buttonAction },
      button
    )
  );
}

TryBanner.propTypes = {
  /**
   * Try Banner title.
   */
  title: index.string,
  /**
   * Text for the button.
   */
  button: index.string,
  /**
   * Action of the button when pressed, this can be a URL (the button will be an anchor tag) or a function (the button will be a button tag).
   */
  buttonAction: index.oneOfType([index.func, index.string]),
  /**
   * Display in dark mode if true.
   */
  dark: index.bool,
  /**
   * Add CSS class selectors to the root element.
   */
  className: index.string
};

TryBanner.defaultProps = {
  title: "Don't have an account yet?",
  button: 'Try Auth0 for Free',
  buttonAction: '#',
  dark: false,
  className: ''
};

var index$3 = createCommonjsModule(function (module) {
	/*!
   Copyright (c) 2017 Jed Watson.
   Licensed under the MIT License (MIT), see
   http://jedwatson.github.io/classnames
 */
	/* global define */

	(function () {
		'use strict';

		var hasOwn = {}.hasOwnProperty;

		function classNames() {
			var classes = [];

			for (var i = 0; i < arguments.length; i++) {
				var arg = arguments[i];
				if (!arg) continue;

				var argType = typeof arg === 'undefined' ? 'undefined' : _typeof(arg);

				if (argType === 'string' || argType === 'number') {
					classes.push(arg);
				} else if (Array.isArray(arg) && arg.length) {
					var inner = classNames.apply(null, arg);
					if (inner) {
						classes.push(inner);
					}
				} else if (argType === 'object') {
					for (var key in arg) {
						if (hasOwn.call(arg, key) && arg[key]) {
							classes.push(key);
						}
					}
				}
			}

			return classes.join(' ');
		}

		if (typeof module !== 'undefined' && module.exports) {
			classNames.default = classNames;
			module.exports = classNames;
		} else if (typeof define === 'function' && _typeof(define.amd) === 'object' && define.amd) {
			// register as 'classnames', consistent with npm package name
			define('classnames', [], function () {
				return classNames;
			});
		} else {
			window.classNames = classNames;
		}
	})();
});

/**
 * Sidebar: Styleguide sidebar with drop drown sections.
 */
var Sidebar = function Sidebar(_ref) {
  var children = _ref.children,
      header = _ref.header,
      mobileNavOpen = _ref.mobileNavOpen,
      toggleNavOnClick = _ref.toggleNavOnClick;

  // TODO: 57px is the height of SidebarItem.
  // Get the height from a json file generated with:
  // https://github.com/nahody/postcss-export-vars
  var heightMenu = React.Children.count(children) * 57;

  return React__default.createElement(
    'div',
    { className: 'a0r-sidebar' },
    React__default.createElement(
      'header',
      { className: 'a0r-sidebar-header' },
      header || React__default.createElement(
        'h1',
        { className: 'default-title' },
        React__default.createElement(
          'a',
          { className: 'default-link', href: '/' },
          React__default.createElement('img', {
            src: 'https://cdn.auth0.com/styleguide/components/1.0.8/media/logos/img/badge.svg',
            alt: 'Auth0 logo',
            width: '30'
          })
        )
      ),
      React__default.createElement(
        'button',
        {
          type: 'button',
          className: index$3('menu-toggle', { 'is-close': mobileNavOpen }),
          onClick: toggleNavOnClick
        },
        React__default.createElement(
          'span',
          { className: 'sr-only' },
          'Toggle navigation'
        ),
        React__default.createElement('span', { className: 'icon-bar' }),
        React__default.createElement('span', { className: 'icon-bar' }),
        React__default.createElement('span', { className: 'icon-bar' }),
        React__default.createElement('span', { className: 'icon-bar' })
      )
    ),
    React__default.createElement(
      'nav',
      { className: 'a0r-sidebar-menu' },
      React__default.createElement(
        'ul',
        {
          className: index$3('menu-list', { 'is-opened': mobileNavOpen }),
          style: { height: heightMenu + 'px' }
        },
        children
      )
    )
  );
};

Sidebar.defaultProps = {
  header: undefined,
  mobileNavOpen: false
};

Sidebar.propTypes = {
  /**
   * Element to replace the default header content.
   */
  header: index.node,
  /**
   * The content of the menu. This is usually used to pass SidebarItem and SidebarSubitem elements.
   */
  children: index.node.isRequired,
  /**
   * Controls whether the navigation is opened or not, only used for mobile.
   */
  mobileNavOpen: index.bool,
  /**
   * Callback fired when on mobile the Toggle Navigation button is pressed.
   */
  toggleNavOnClick: index.func
};

Sidebar.defaultProps = {
  open: false,
  toggleNavOnClick: function toggleNavOnClick() {}
};

var SidebarItem = function SidebarItem(_ref) {
  var text = _ref.text,
      wrapper = _ref.wrapper,
      arrow = _ref.arrow,
      icon = _ref.icon,
      children = _ref.children,
      open = _ref.open;

  var heightMenu = React.Children.count(children) * 45 - 1;
  var WrapperItemChildren = function WrapperItemChildren() {
    return React__default.createElement(
      'span',
      { className: 'menu-item-link' },
      icon && React__default.createElement('span', { className: 'menu-item-icon icon-budicon-' + icon }),
      React__default.createElement(
        'span',
        { className: 'text' },
        text
      ),
      arrow && React__default.createElement('i', { className: 'icon-budicon-519 pull-right' })
    );
  };

  return React__default.createElement(
    'li',
    { className: 'a0r-sidebar-menu-item ' + (open ? 'active' : '') },
    React.cloneElement(wrapper, { children: React__default.createElement(WrapperItemChildren, null) }),
    children ? React__default.createElement(
      'ul',
      {
        className: index$3('menu-sublist', { 'is-opened': open }),
        style: { height: heightMenu + 'px' }
      },
      children
    ) : null
  );
};

SidebarItem.defaultProps = {
  arrow: false,
  icon: undefined,
  children: undefined,
  open: false
};

SidebarItem.propTypes = {
  /**
   * Text of the item.
   */
  text: index.string.isRequired,
  /**
   * Wrapper element around the inner content of the item.
   */
  wrapper: index.node,
  /**
   * Enable arrow icon.
   */
  arrow: index.bool,
  /**
   * Show Item with an icon from Budicon.
   */
  icon: index.number,
  /**
   * The content of the menu. This is usually used to pass SidebarSubitem elements.
   */
  children: index.node,
  /**
   * Controls whether the subitems are showed or not.
   */
  open: index.bool
};

SidebarItem.defaultProps = {
  wrapper: React__default.createElement('span', null)
};

var SidebarSubitem = function SidebarSubitem(_ref) {
  var text = _ref.text,
      wrapper = _ref.wrapper;

  var WrapperSubitemChildren = function WrapperSubitemChildren() {
    return React__default.createElement(
      'span',
      { className: 'menu-subitem-link' },
      React__default.createElement(
        'span',
        { className: 'text' },
        text
      )
    );
  };

  return React__default.createElement(
    'li',
    { className: 'a0r-sidebar-menu-subitem' },
    React.cloneElement(wrapper, { children: React__default.createElement(WrapperSubitemChildren, null) })
  );
};

SidebarSubitem.propTypes = {
  /**
   * Text of the item.
   */
  text: index.string.isRequired,
  /**
   * Wrapper element around the inner content of the item.
   */
  wrapper: index.node
};

SidebarSubitem.defaultProps = {
  wrapper: React__default.createElement('span', null)
};

// auth0 components

exports.EmptyState = EmptyState;
exports.Footer = Footer;
exports.Select = Select;
exports.TryBanner = TryBanner;
exports.Sidebar = Sidebar;
exports.SidebarItem = SidebarItem;
exports.SidebarSubitem = SidebarSubitem;

Object.defineProperty(exports, '__esModule', { value: true });

})));
